

#ifndef THREADS_H_INCLUDED
#define THREADS_H_INCLUDED


#define NUM_THREADS 100

#define THREAD_OK 0
#define THREAD_MUTEX_LOCK 1
#define THREAD_MUTEX_UNLOCK 2

typedef struct 
{


#ifdef HAVE_PTHREAD
   time_t spawned;

   pthread_t tid;

   pthread_mutex_t lock;

   pthread_cond_t cond;

   pthread_attr_t attr;

   void (*cleanup)(void *);

   void *params;


#endif

} Thread;


dlink_list threadlist;


Thread* spawn_thread(void* params, void (*init_fnct)(void *),void (*exit_fnct)(void *));

Thread* find_thread();
int dest_thread	();

int mutex_state			(Thread* ,int);
void dest_all_threads	(void);
int thread_wait			(Thread*, pthread_cond_t*);
int thread_signal		(pthread_cond_t*);
int thread_cancle		(Thread*);
int thread_count;




#endif // THREADS_H_INCLUDED
